using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using oktellClient.Controls;

namespace OktellPlugin
{

	/// <summary>
	///   ""
	/// </summary>
	public class Control03 : System.Windows.Forms.UserControl
	{
		#region   .
		private oktellClient.Controls.oktellUpDownButton btnShowHide;
		private System.Windows.Forms.Panel panel12;
		private System.Windows.Forms.Panel panel11;
		private System.Windows.Forms.Panel pnlParent;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel13;
		private oktellClient.Controls.oktellButton btnFilter;
		private System.Windows.Forms.Label lblList;
		private System.Windows.Forms.Label lblFilter;
		private System.Windows.Forms.Label vrt1;
		private System.Windows.Forms.Label lblTip_work;
		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.Label vrt2;
		private oktellClient.Controls.oktellComboCheckSet setType;
		private System.ComponentModel.Container components = null;
		private oktellClient.Controls.oktellCalendarComboBox dateInterval;
		private oktellClient.Controls.OGrid2 GrdControl;

		private Hashtable TypeByID = new Hashtable();

		public event Base.PluginQueryInvoker OnQuery;
		public event ControlParent.FinishEditHandler OnFinish;
		#endregion

		#region Common
		public Control03()
		{
			InitializeComponent();

			TreeSimpleItemInfo item;
			Base.TypeComboItems Tag;

			#region  


			item = new TreeSimpleItemInfo ();
			item.Checked = true;
			item.Tag = Tag = new Base.TypeComboItems("()","",1);
			TypeByID[Tag.Code] = item.Text = Tag.Caption;
			setType.Items.Add ( item );
			
			item = new TreeSimpleItemInfo ();
			item.Checked = true;
			item.Tag = Tag = new Base.TypeComboItems("()","",2);
			TypeByID[Tag.Code] = item.Text = Tag.Caption;
			setType.Items.Add ( item );
			
			item = new TreeSimpleItemInfo ();
			item.Checked = true;
			item.Tag = Tag = new Base.TypeComboItems(" . ","Email",3);
			TypeByID[Tag.Code] = item.Text = Tag.Caption;
			setType.Items.Add ( item );

			item = new TreeSimpleItemInfo ();
			item.Checked = true;
			item.Tag = Tag = new Base.TypeComboItems(" ","Fax",4);
			TypeByID[Tag.Code] = item.Text = Tag.Caption;
			setType.Items.Add ( item );

			item = new TreeSimpleItemInfo ();
			item.Checked = true;
			item.Tag = Tag = new Base.TypeComboItems("","Spam",5);
			TypeByID[Tag.Code] = item.Text = Tag.Caption;
			setType.Items.Add ( item );

			#endregion

			dateInterval.DateStart = DateTime.Now;
			dateInterval.DateStop = DateTime.Now;
			dateInterval.SetText();

			GrdControl.CustomDrawCell += new oktellClient.Controls.OGrid2.CustomDrawHandler(GrdControl_CustomDrawCell);

			this.Dock = DockStyle.Fill;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            oktell.UI.ControlButton controlButton1 = new oktell.UI.ControlButton ();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager (typeof (Control03));
            oktell.UI.ControlButton controlButton2 = new oktell.UI.ControlButton ();
            this.pnlParent = new System.Windows.Forms.Panel ();
            this.panel2 = new System.Windows.Forms.Panel ();
            this.GrdControl = new oktellClient.Controls.OGrid2 ();
            this.lblList = new System.Windows.Forms.Label ();
            this.panel1 = new System.Windows.Forms.Panel ();
            this.panel13 = new System.Windows.Forms.Panel ();
            this.vrt2 = new System.Windows.Forms.Label ();
            this.btnFilter = new oktellClient.Controls.oktellButton ();
            this.btnShowHide = new oktellClient.Controls.oktellUpDownButton ();
            this.lblFilter = new System.Windows.Forms.Label ();
            this.panel12 = new System.Windows.Forms.Panel ();
            this.dateInterval = new oktellClient.Controls.oktellCalendarComboBox ();
            this.vrt1 = new System.Windows.Forms.Label ();
            this.lblTip_work = new System.Windows.Forms.Label ();
            this.panel11 = new System.Windows.Forms.Panel ();
            this.setType = new oktellClient.Controls.oktellComboCheckSet ();
            this.lblName = new System.Windows.Forms.Label ();
            this.pnlParent.SuspendLayout ();
            this.panel2.SuspendLayout ();
            this.panel1.SuspendLayout ();
            this.panel13.SuspendLayout ();
            ((System.ComponentModel.ISupportInitialize) (this.btnShowHide)).BeginInit ();
            this.panel12.SuspendLayout ();
            this.panel11.SuspendLayout ();
            this.SuspendLayout ();
            // 
            // pnlParent
            // 
            this.pnlParent.Anchor = ((System.Windows.Forms.AnchorStyles) ((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlParent.Controls.Add (this.panel2);
            this.pnlParent.Controls.Add (this.panel1);
            this.pnlParent.Location = new System.Drawing.Point (8, 8);
            this.pnlParent.Name = "pnlParent";
            this.pnlParent.Size = new System.Drawing.Size (782, 464);
            this.pnlParent.TabIndex = 3;
            // 
            // panel2
            // 
            this.panel2.Controls.Add (this.GrdControl);
            this.panel2.Controls.Add (this.lblList);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel2.Location = new System.Drawing.Point (0, 72);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size (782, 392);
            this.panel2.TabIndex = 10;
            // 
            // GrdControl
            // 
            this.GrdControl.AllowColumnResize = true;
            this.GrdControl.AllowSort = true;
            this.GrdControl.AllowToolTip = false;
            this.GrdControl.Anchor = ((System.Windows.Forms.AnchorStyles) ((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.GrdControl.BackColor = System.Drawing.Color.White;
            this.GrdControl.BorderColor = System.Drawing.Color.FromArgb (((int) (((byte) (120)))), ((int) (((byte) (133)))), ((int) (((byte) (144)))));
            this.GrdControl.BorderWidth = 1;
            this.GrdControl.Columns = new oktellClient.Controls.OGrid2.CDataColumn [ 0 ];
            this.GrdControl.DataSource = null;
            this.GrdControl.DisabledBackColor = System.Drawing.Color.Empty;
            this.GrdControl.DisabledForeColor = System.Drawing.Color.Empty;
            this.GrdControl.DrawLines = false;
            this.GrdControl.FocusedColumn = null;
            this.GrdControl.Font = new System.Drawing.Font ("Microsoft Sans Serif", 11.33333F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.GrdControl.HeaderColor = System.Drawing.Color.Transparent;
            this.GrdControl.HeaderHeight = 22;
            this.GrdControl.HighLightColor = System.Drawing.Color.Empty;
            this.GrdControl.HoverColor = System.Drawing.Color.FromArgb (((int) (((byte) (15)))), ((int) (((byte) (0)))), ((int) (((byte) (60)))), ((int) (((byte) (120)))));
            this.GrdControl.LineColor = System.Drawing.Color.White;
            this.GrdControl.LoadColumnWidthFromRegistry = true;
            this.GrdControl.Location = new System.Drawing.Point (0, 32);
            this.GrdControl.MultiSelect = false;
            this.GrdControl.Name = "GrdControl";
            this.GrdControl.SelectColor = System.Drawing.Color.FromArgb (((int) (((byte) (231)))), ((int) (((byte) (237)))), ((int) (((byte) (242)))));
            this.GrdControl.Size = new System.Drawing.Size (781, 360);
            this.GrdControl.SplitterColor = System.Drawing.Color.FromArgb (((int) (((byte) (0)))), ((int) (((byte) (0)))), ((int) (((byte) (0)))), ((int) (((byte) (0)))));
            this.GrdControl.SplitterDownColor = System.Drawing.Color.FromArgb (((int) (((byte) (51)))), ((int) (((byte) (0)))), ((int) (((byte) (0)))), ((int) (((byte) (0)))));
            this.GrdControl.TabIndex = 14;
            this.GrdControl.Text = "oGrid21";
            this.GrdControl.TopPixel = 0;
            this.GrdControl.TopRowIndex = 0;
            // 
            // lblList
            // 
            this.lblList.AutoSize = true;
            this.lblList.Font = new System.Drawing.Font ("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.lblList.Location = new System.Drawing.Point (8, 8);
            this.lblList.Name = "lblList";
            this.lblList.Size = new System.Drawing.Size (107, 15);
            this.lblList.TabIndex = 0;
            this.lblList.Text = " :";
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.Color.FromArgb (((int) (((byte) (230)))), ((int) (((byte) (240)))), ((int) (((byte) (230)))));
            this.panel1.Controls.Add (this.panel13);
            this.panel1.Controls.Add (this.btnShowHide);
            this.panel1.Controls.Add (this.lblFilter);
            this.panel1.Controls.Add (this.panel12);
            this.panel1.Controls.Add (this.panel11);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point (0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size (782, 72);
            this.panel1.TabIndex = 0;
            this.panel1.Resize += new System.EventHandler (this.panel1_Resize);
            // 
            // panel13
            // 
            this.panel13.Anchor = ((System.Windows.Forms.AnchorStyles) ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.panel13.Controls.Add (this.vrt2);
            this.panel13.Controls.Add (this.btnFilter);
            this.panel13.Location = new System.Drawing.Point (662, 32);
            this.panel13.Name = "panel13";
            this.panel13.Size = new System.Drawing.Size (120, 40);
            this.panel13.TabIndex = 5;
            // 
            // vrt2
            // 
            this.vrt2.BackColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (182)))), ((int) (((byte) (109)))));
            this.vrt2.Font = new System.Drawing.Font ("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.vrt2.Location = new System.Drawing.Point (0, 4);
            this.vrt2.Name = "vrt2";
            this.vrt2.Size = new System.Drawing.Size (2, 20);
            this.vrt2.TabIndex = 0;
            // 
            // btnFilter
            // 
            this.btnFilter.BackColor = System.Drawing.Color.FromArgb (((int) (((byte) (221)))), ((int) (((byte) (231)))), ((int) (((byte) (197)))));
            this.btnFilter.BackColor2 = System.Drawing.Color.FromArgb (((int) (((byte) (235)))), ((int) (((byte) (240)))), ((int) (((byte) (220)))));
            this.btnFilter.BackColor3 = System.Drawing.Color.White;
            this.btnFilter.BackColorPressedBorder = System.Drawing.Color.Empty;
            this.btnFilter.BackColorPressedBottom = System.Drawing.Color.Empty;
            this.btnFilter.BackColorPressedTop = System.Drawing.Color.Empty;
            this.btnFilter.BorderColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (192)))), ((int) (((byte) (109)))));
            this.btnFilter.ColorGroup = oktellClient.Controls.EColorGroup.cgOffice;
            this.btnFilter.DialogResult = System.Windows.Forms.DialogResult.None;
            this.btnFilter.Image = null;
            this.btnFilter.Location = new System.Drawing.Point (10, 0);
            this.btnFilter.Name = "btnFilter";
            this.btnFilter.ShowFocusRect = true;
            this.btnFilter.Size = new System.Drawing.Size (96, 24);
            this.btnFilter.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
            this.btnFilter.TabIndex = 3;
            this.btnFilter.Text = "";
            this.btnFilter.UseColorGroup = true;
            this.btnFilter.Click += new System.EventHandler (this.btnFilter_Click_1);
            // 
            // btnShowHide
            // 
            this.btnShowHide.Anchor = ((System.Windows.Forms.AnchorStyles) ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnShowHide.ButtonColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (192)))), ((int) (((byte) (109)))));
            this.btnShowHide.ButtonType = oktellClient.Controls.EUpDownButtonType.Up;
            this.btnShowHide.Font = new System.Drawing.Font ("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.btnShowHide.Location = new System.Drawing.Point (758, 8);
            this.btnShowHide.Name = "btnShowHide";
            this.btnShowHide.Size = new System.Drawing.Size (12, 12);
            this.btnShowHide.TabIndex = 4;
            this.btnShowHide.TabStop = false;
            this.btnShowHide.Click += new System.EventHandler (this.btnShowHide_Click);
            // 
            // lblFilter
            // 
            this.lblFilter.AutoSize = true;
            this.lblFilter.Font = new System.Drawing.Font ("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.lblFilter.ForeColor = System.Drawing.Color.Black;
            this.lblFilter.Location = new System.Drawing.Point (8, 8);
            this.lblFilter.Name = "lblFilter";
            this.lblFilter.Size = new System.Drawing.Size (56, 15);
            this.lblFilter.TabIndex = 0;
            this.lblFilter.Text = ":";
            // 
            // panel12
            // 
            this.panel12.Controls.Add (this.dateInterval);
            this.panel12.Controls.Add (this.vrt1);
            this.panel12.Controls.Add (this.lblTip_work);
            this.panel12.Location = new System.Drawing.Point (304, 32);
            this.panel12.Name = "panel12";
            this.panel12.Size = new System.Drawing.Size (360, 40);
            this.panel12.TabIndex = 0;
            // 
            // dateInterval
            // 
            this.dateInterval.AllowEdit = true;
            this.dateInterval.Anchor = ((System.Windows.Forms.AnchorStyles) (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.dateInterval.AutoUpdateEditValue = false;
            this.dateInterval.BorderColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (192)))), ((int) (((byte) (109)))));
            controlButton1.ButtonDown = ((System.Drawing.Bitmap) (resources.GetObject ("controlButton1.ButtonDown")));
            controlButton1.ButtonHover = ((System.Drawing.Bitmap) (resources.GetObject ("controlButton1.ButtonHover")));
            controlButton1.ButtonUp = ((System.Drawing.Bitmap) (resources.GetObject ("controlButton1.ButtonUp")));
            controlButton1.Width = 16;
            this.dateInterval.ButtonRight = controlButton1;
            this.dateInterval.CalendarType = oktellClient.Controls.ECalendarType.ctPeriod;
            this.dateInterval.DateStart = new System.DateTime (2009, 4, 17, 0, 0, 0, 0);
            this.dateInterval.DateStop = new System.DateTime (2009, 4, 17, 23, 59, 59, 964);
            this.dateInterval.DisabledBackColor = System.Drawing.Color.Empty;
            this.dateInterval.DisabledBorderColor = System.Drawing.Color.Empty;
            this.dateInterval.DisabledForeColor = System.Drawing.Color.Empty;
            this.dateInterval.EditValue = "17.04.2009 - 17.04.2009";
            this.dateInterval.ForeColor = System.Drawing.Color.Black;
            this.dateInterval.HighLightColor = System.Drawing.Color.FromArgb (((int) (((byte) (204)))), ((int) (((byte) (223)))), ((int) (((byte) (183)))));
            this.dateInterval.Location = new System.Drawing.Point (96, 4);
            this.dateInterval.MainColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (192)))), ((int) (((byte) (109)))));
            this.dateInterval.Mask = "00.00.0000 - 00.00.0000";
            this.dateInterval.Name = "dateInterval";
            this.dateInterval.SelectedIndex = -1;
            this.dateInterval.SelectedItem = null;
            this.dateInterval.SelectedText = "";
            this.dateInterval.SelectionLength = 0;
            this.dateInterval.SelectionStart = 0;
            this.dateInterval.Size = new System.Drawing.Size (256, 20);
            this.dateInterval.TabIndex = 2;
            this.dateInterval.Text = "17.04.2009 - 17.04.2009";
            this.dateInterval.UseLeftDots = false;
            // 
            // vrt1
            // 
            this.vrt1.BackColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (182)))), ((int) (((byte) (109)))));
            this.vrt1.Font = new System.Drawing.Font ("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.vrt1.Location = new System.Drawing.Point (0, 4);
            this.vrt1.Name = "vrt1";
            this.vrt1.Size = new System.Drawing.Size (2, 20);
            this.vrt1.TabIndex = 0;
            // 
            // lblTip_work
            // 
            this.lblTip_work.AutoSize = true;
            this.lblTip_work.Font = new System.Drawing.Font ("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.lblTip_work.ForeColor = System.Drawing.Color.Gray;
            this.lblTip_work.Location = new System.Drawing.Point (8, 7);
            this.lblTip_work.Name = "lblTip_work";
            this.lblTip_work.Size = new System.Drawing.Size (85, 13);
            this.lblTip_work.TabIndex = 0;
            this.lblTip_work.Text = " :";
            // 
            // panel11
            // 
            this.panel11.Controls.Add (this.setType);
            this.panel11.Controls.Add (this.lblName);
            this.panel11.Location = new System.Drawing.Point (0, 32);
            this.panel11.Name = "panel11";
            this.panel11.Size = new System.Drawing.Size (296, 40);
            this.panel11.TabIndex = 0;
            // 
            // setType
            // 
            this.setType.Anchor = ((System.Windows.Forms.AnchorStyles) (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.setType.AutoHeight = true;
            this.setType.AutoHeightMinS2 = false;
            this.setType.AutoWidth = true;
            this.setType.BorderColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (192)))), ((int) (((byte) (109)))));
            controlButton2.ButtonDown = ((System.Drawing.Bitmap) (resources.GetObject ("controlButton2.ButtonDown")));
            controlButton2.ButtonHover = ((System.Drawing.Bitmap) (resources.GetObject ("controlButton2.ButtonHover")));
            controlButton2.ButtonUp = ((System.Drawing.Bitmap) (resources.GetObject ("controlButton2.ButtonUp")));
            controlButton2.Width = 18;
            this.setType.ButtonRight = controlButton2;
            this.setType.ColorGroup = oktellClient.Controls.EColorGroup.cgOffice;
            this.setType.DisabledBackColor = System.Drawing.Color.Empty;
            this.setType.DisabledBorderColor = System.Drawing.Color.Empty;
            this.setType.DisabledForeColor = System.Drawing.Color.Empty;
            this.setType.EditValue = "";
            this.setType.ForeColor = System.Drawing.Color.Black;
            this.setType.Location = new System.Drawing.Point (88, 4);
            this.setType.MainColor = System.Drawing.Color.FromArgb (((int) (((byte) (152)))), ((int) (((byte) (192)))), ((int) (((byte) (109)))));
            this.setType.Name = "setType";
            this.setType.PopupWindowHeight = 150;
            this.setType.ReadOnly = true;
            this.setType.SelectionLength = 0;
            this.setType.SelectionStart = 0;
            this.setType.ShouldUpdateText = true;
            this.setType.Size = new System.Drawing.Size (200, 20);
            this.setType.TabIndex = 1;
            this.setType.TextEditStyle = oktellClient.Controls.TextEditStyles.DisableTextEditor;
            this.setType.ViewOnly = true;
            // 
            // lblName
            // 
            this.lblName.AutoSize = true;
            this.lblName.Font = new System.Drawing.Font ("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
            this.lblName.ForeColor = System.Drawing.Color.Gray;
            this.lblName.Location = new System.Drawing.Point (8, 7);
            this.lblName.Name = "lblName";
            this.lblName.Size = new System.Drawing.Size (78, 13);
            this.lblName.TabIndex = 0;
            this.lblName.Text = " :";
            // 
            // Control03
            // 
            this.Controls.Add (this.pnlParent);
            this.Name = "Control03";
            this.Size = new System.Drawing.Size (798, 480);
            this.pnlParent.ResumeLayout (false);
            this.panel2.ResumeLayout (false);
            this.panel2.PerformLayout ();
            this.panel1.ResumeLayout (false);
            this.panel1.PerformLayout ();
            this.panel13.ResumeLayout (false);
            ((System.ComponentModel.ISupportInitialize) (this.btnShowHide)).EndInit ();
            this.panel12.ResumeLayout (false);
            this.panel12.PerformLayout ();
            this.panel11.ResumeLayout (false);
            this.panel11.PerformLayout ();
            this.ResumeLayout (false);

		}
		#endregion

		private void panel1_Resize(object sender, System.EventArgs e)
		{
			panel12.Left = panel11.Width = (panel1.Width-panel13.Width)/2;
			panel12.Width = panel1.Width - panel13.Width - panel11.Width;
			//panel2.Top = panel1.Height;
		}
		#endregion

		private void btnShowHide_Click(object sender, System.EventArgs e)
		{
			if (panel1.Height != 32 )
				panel1.Height = 32;
			else
				panel1.Height = panel12.Height+panel12.Top;
		}

		private void buttonBar_OnButtonPressed(object Tag)
		{
			switch ((int) Tag )
			{
				case 1:
					//
					if (OnFinish!=null)
						OnFinish(false);
					break;
				case 2:
					//
					if (OnFinish!=null)
						OnFinish(true);
					break;
			}
		}

		private void btnFilter_Click(object sender, System.EventArgs e)
		{
		
		}
//		private void setType_QueryDisplayText(object sender, DevExpress.XtraEditors.Controls.QueryDisplayTextEventArgs e)
//		{
//			oktellComboCheckSet combo = sender as oktellComboCheckSet;
//			if (combo == null)
//				return;
//			TreeSimpleItemCollection Items = combo.Items;
//			
//			string txt = "";
//			bool All = true;
//			int CheckCnt = 0;
//			for (int i = 0; i<Items.Count; i++)
//			{
//				Base.TypeComboItems Tag = (Base.TypeComboItems) Items[i].Tag;
//				if (Items[i].Checked)
//				{
//					if (txt == "")
//						txt = Tag.ShortName;
//					else
//						txt += ", " + Tag.ShortName;
//					CheckCnt++;
//				}
//				else
//					All = false;
//			}
//
//			if (txt == "")
//				e.DisplayText = "  ";
//			else
//			{
//				if ((CheckCnt>1)&&(All))
//					e.DisplayText = "";
//				else
//					e.DisplayText = txt;
//			}
//		}

		private void btnFilter_Click_1(object sender, System.EventArgs e)
		{
			ArrayList source = new ArrayList();

			#region      xml


			string Type = "*";
			for (int i = 0; i<setType.Items.Count; i++)
			{
				Base.TypeComboItems Tag = (Base.TypeComboItems) setType.Items[i].Tag;
				if (setType.Items[i].Checked)
					Type = Type + Tag.Code + "*";
			}

			//SQL- 
			string SQLtext = "Exec dbo.C_ClientsPlugin_GetContactByID " + Base.EditValue.Id.ToString() + ", '" + Type + "', '" + dateInterval.DateStart.ToString ("MM.dd.yyyy") + "', '" + dateInterval.DateStop.ToString ("MM.dd.yyyy") + "'";

			//MessageBox.Show ( SQLtext );
					
			// XML
			CMapperXmlItemSetCollection icoll = new CMapperXmlItemSetCollection (  );
			CMapperXmlItemSet iset = new CMapperXmlItemSet ();
			icoll.Add ( iset );
			iset.Name = "db";
			iset.Add ( CMapperXmlItem.GetItem ( "sqltext", SQLtext ) );
			string query = icoll.WriteToXml ( "query" );

			string xml = "";
			if (OnQuery!=null)
				xml = OnQuery(query);
			else
				return;

			#endregion

			#region  xml
			CMapperXmlItemSetCollection coll = CMapperXmlItemSetCollection.FromXml ( xml );
			if ( coll == null )
			{
				OnQuery (
					"<?xml version=\"1.0\" encoding=\"utf-16\"?>" +
					"<oktellxmlmapper version=\"80710\">" +
					"<data name=\"query\" count=\"1\">" +
					"	<property_set name=\"notify\">" +
					"	<property_cdata key=\"type\" ><![CDATA[warn]]></property_cdata>" +
					"	<property_cdata key=\"text\"><![CDATA[  ]]></property_cdata>" +
					"	</property_set>" +
					"</data>" +
					"</oktellxmlmapper>"
					);
				return;
			}
			else	
			{
				coll = coll [ 0 ].SubSets;
				CMapperXmlItemSetCollection coll2;
				CMapperXmlItemSetCollection coll3;

				if ( coll.Count < 2 )
				{
					OnQuery (
						"<?xml version=\"1.0\" encoding=\"utf-16\"?>" +
						"<oktellxmlmapper version=\"80710\">" +
						"<data name=\"query\" count=\"1\">" +
						"	<property_set name=\"notify\">" +
						"	<property_cdata key=\"type\" ><![CDATA[warn]]></property_cdata>" +
						"	<property_cdata key=\"text\"><![CDATA[  ]]></property_cdata>" +
						"	</property_set>" +
						"</data>" +
						"</oktellxmlmapper>"
						);
					return;
				}
				else
				{
					CMapperXmlItemSet headset = null;
					CMapperXmlItemSet dataset = null;

					for ( int i = 0; i < coll.Count; i++ )
					{
						CMapperXmlItemSet tset = coll [ i ];
						switch ( tset.Name.ToLower() )
						{
							case "tableheader":
								headset = tset;
								break;

							case "tabledata":
								dataset = tset;
								break;
						}
					}

					if (( headset != null ) && ( dataset != null ))
					{
						Hashtable hash = new Hashtable ();

						#region  
						coll = headset.SubSets;
						//  
						for ( int i = 0; i < coll.Count; i++ )
						{
							CMapperXmlItemSet tset = coll [ i ];
							if (tset.Count > 0 )
							{
								string tmps = CMapperXmlItem.GetValueName ( tset[0] );
								string Id = tset.IdName;
								string Value = null;
								for ( int i4 = 0; i4 < tset.Count; i4++ )
									if ( tset[i4].Key.ToLower() == "name" )
										Value = CMapperXmlItem.GetValueName (tset[i4] );
								hash [ Id ] = Value;
							}
						}
						#endregion

						#region  
						coll2 = dataset.SubSets;
						//  
						if ( coll2.Count < 1 )
						{
							OnQuery (
								"<?xml version=\"1.0\" encoding=\"utf-16\"?>" +
								"<oktellxmlmapper version=\"80710\">" +
								"<data name=\"query\" count=\"1\">" +
								"	<property_set name=\"notify\">" +
								"	<property_cdata key=\"type\" ><![CDATA[warn]]></property_cdata>" +
								"	<property_cdata key=\"text\"><![CDATA[  ]]></property_cdata>" +
								"	</property_set>" +
								"</data>" +
								"</oktellxmlmapper>"
								);
							return;
						}

						for ( int i2 = 0; i2 < coll2.Count; i2++ )
						{
							Base.UserContact field = new OktellPlugin.Base.UserContact();
							
							CMapperXmlItemSet tset = coll2 [ i2 ];
							coll3 = tset.SubSets;
							//  
							for ( int i3 = 0; i3 < coll3.Count; i3++ )
							{
								tset = coll3 [ i3 ];
								if (tset.Count > 0 )
								{
									
									string tmps = CMapperXmlItem.GetValueName ( tset[0] );

									switch ( (hash [tset.IdName] as string).ToLower() )
									{
										case "idconn":
											field.IDConn = new Guid ( tmps );
											break;
										case "type":
											field.Type = int.Parse(tmps);
											break;
										case "userid":
											field.UserID = new Guid(tmps);
											break;
										case "username":
											field.Manager = tmps;
											break;
										case "date":
											try
											{
												field.Date = DateTime.Parse (tmps);
											}
											catch
											{
												field.Date = DateTime.Now;
											}

											break;
										case "attach":
											field.Attach = tmps;
											break;
										case "text":
											field.Text = tmps;
											break;
										case "length":
											field.Length = int.Parse ( tmps );
											break;
									}

								}
							}
							source.Add ( field );

						}
						#endregion
					}
				}

			}
			#endregion

			GrdControl.DataSource = source;
			GrdControl.Refresh();
		}

		OGrid2.CDataColumn ColDate = new OGrid2.CDataColumn ( " ", "Date" );
		OGrid2.CDataColumn ColContactType = new OGrid2.CDataColumn ( " ", "ContactType" );
		OGrid2.CDataColumn ColManager = new OGrid2.CDataColumn ( "", "Manager" );
		OGrid2.CDataColumn ColAttach = new OGrid2.CDataColumn ( "", "AttachStr" );

		private void oktellComboBox21_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			g.DrawLine ( Pens.Red, 0, 0, 10, 10 );	
		}


		private oktellClient.Controls.oktellMediaPlayer player = null;
		private void GrdView_DoubleClick(object sender, System.EventArgs e)
		{
			MouseEventArgs ma = e as MouseEventArgs;

			Point p = GrdControl.PointToClient(Control.MousePosition);
			OGrid2.GridHitInfo hitInfo = GrdControl.CalcHitInfo(p);
			if ( (ma == null || ma.Button==MouseButtons.Left) && hitInfo.InRowCell && hitInfo.Column == ColAttach && hitInfo.RowHandle == GrdControl.FocusedRowHandle )
			{
				Base.UserContact cont = GrdControl.GetRow ( hitInfo.RowHandle ) as Base.UserContact;

				if (cont != null)
				{
					switch ( cont.Type )
					{
						case 1:
						case 2:
							Random r = new Random ();
							string filename = Base.TmpDir + r.Next ( 100000000, 999999999 ) + ".wav";
							string s =
								OnQuery (
								"<?xml version=\"1.0\" encoding=\"utf-16\"?>" +
								"<oktellxmlmapper version=\"80710\">" +
								"<data name=\"query\" count=\"1\">" +
								"<property_set name=\"downloadrecordbyid\" id=\"ghs\">" +
								"<property_cdata key=\"idconn\"><![CDATA[" + cont.IDConn + "]]></property_cdata>" +
								"<property_cdata key=\"filepath\"><![CDATA[" + filename + "]]></property_cdata>" +
								"</property_set>" +
								"</data>" +
								"</oktellxmlmapper>"
								);

							if ( player != null )
								player.Dispose();
							player = new oktellMediaPlayer ();
							player.ParentGlue = 0;
							player.Parent = this;
							player.BringToFront();
							player.Show();
							player.PlayFile ( filename, "" );
							player.StartPlay();
							break;
						default:
							if ( cont.Attach != "" )
							{
								try
								{
									System.Diagnostics.Process pr = new System.Diagnostics.Process ();
									pr.StartInfo = new System.Diagnostics.ProcessStartInfo ( cont.Attach );
									pr.StartInfo.Verb = "open";
									pr.Start ();
								}
								catch
								{
								}
							}
							break;
					}
				}
			}
		}

		private void GrdControl_CustomDrawCell(object sender, oktellClient.Controls.OGrid2.CustomDrawEventArgs e)
		{
			if ( e.Column == ColContactType )
			{
				int idx = GrdControl.GetDataSourceRowIndex(e.RowHandle);
				ArrayList source = (ArrayList) GrdControl.DataSource;
				Base.UserContact field = (Base.UserContact) source[idx];

				if ( TypeByID.Contains(field.Type) )
				{
					string display = (string) TypeByID[field.Type];
					e.DisplayText = display;
				}
			}
			if ( e.Column == ColAttach )
			{
				int idx = GrdControl.GetDataSourceRowIndex(e.RowHandle);
				ArrayList source = (ArrayList) GrdControl.DataSource;
				Base.UserContact field = (Base.UserContact) source[idx];
				if ( field.Type == 1 || field.Type == 2 )
				{
					if ( field.Length >= 0 )
					{
						int min = field.Length/60;
						int sec = field.Length%60;
						e.DisplayText = "     " + (min<10?("0"+min):min.ToString()) + ":" + (sec<10?("0"+sec):sec.ToString());
						int w = 8;
						int l = e.Bounds.Left+2; // e.Bounds.Left + (e.Bounds.Width-w)/2;
						int t = e.Bounds.Top + (e.Bounds.Height-w)/2;

						Font font = new Font ( e.Appearance.Font.Name, e.Appearance.Font.Size );
						e.Appearance.Font = font;

						e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

						SolidBrush br = new SolidBrush ( Color.FromArgb( 230, 130, 120 ) );
						e.Graphics.FillEllipse ( br, l, t, w, w );

						br.Dispose ();
					}
					else
						e.DisplayText = "< >";
				}
				else
				{
					if ( field.Attach == "" )
					{
						e.DisplayText = "< >";
						Font font = new Font ( e.Appearance.Font.Name, e.Appearance.Font.Size );
						e.Appearance.Font = font;
					}
				}
			}
		}
	}
}
